<template>
  <div
    class="message"
    :class="{ personal }"
  >
    <div
      v-if="personal === false"
      class="avatar"
    >
      <UserProfileMenu :user="message.author">
        <UserProfile :user="message.author" />
      </UserProfileMenu>
    </div>
    <div class="message-container">
      <div
        class="message-info"
        :class="{ personal }"
      >
        <JText
          v-if="personal === false"
          type="text-2"
          color="text"
          weight="normal"
          class="message-author"
        >
          {{ message.author.name }}
        </JText>
        <JText
          type="text-3"
          color="text"
          weight="normal"
        >
          <MessageTime
            only-format
            :message="message"
          />
        </JText>
      </div>
      <div
        class="message-content-wrapper"
        :class="{ personal }"
      >
        <ReplyMessage
          v-if="message.replyTo && message.deletedDate === null"
          :message="message.replyTo"
          hide-close
        />
        <DeletedMessage
          v-if="message.deletedDate"
          :hide-restore-btn="personal === false"
          @restore="$emit('restore')"
        />
        <p
          v-else
          v-html="message.content"
          class="message-content"
        />
      </div>
    </div>

    <div
      v-if="personal"
      class="message-status"
      :class="{ empty: message.delivered === false }"
    >
      <JIcon
        :icon="message.delivered ? 'delivered' : 'notDelivered'"
        size="16px"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
import { PropType } from 'vue';
import { JIcon, JText } from '@new-jira-clone/ui/src/components';
import { UserProfile, UserProfileMenu } from '@/features/user-profile';
import { IMessage } from '@/shared';
import MessageTime from './MessageTime.vue';
import ReplyMessage from './ReplyMessage.vue';
import DeletedMessage from './DeletedMessage.vue';

defineProps({
  personal: {
    type: Boolean,
    default: false,
  },
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
});

defineEmits<{
  (event: 'restore'): void;
}>();
</script>

<style lang="scss" scoped>
.message {
  display: flex;
  position: relative;
  min-width: 200px;
  width: 100%;

  &.personal {
    justify-content: flex-end;
  }

  &:focus-visible {
    outline: var(--j-focus-outline);
  }
}

.message-container {
  flex-shrink: 2;
  max-width: max-content;
}

.message-info {
  display: flex;
  align-items: center;

  &.personal {
    flex-direction: row-reverse;
  }
}

.message-author {
  margin-right: 12px;
}

.message-content-wrapper {
  padding: 8px 16px;
  max-width: 800px;
  border-radius: 12px;
  transition: 50ms;
  color: rgb(var(--j-secondary-title-color));
  background-color: #f5f5f5;

  &:not(.personal) {
    border-top-left-radius: 0;
  }

  &.personal {
    border-bottom-right-radius: 0;
    background-color: var(--j-primary-color-lighten1);
  }
}

.message-content {
  word-break: break-word;

  :deep(p) {
    min-height: 20px;
  }

  :deep(a) {
    color: rgb(var(--j-primary-color));
    text-decoration: underline;
  }
}

.message-status {
  display: flex;
  position: absolute;
  right: -26px;
  bottom: 0;
  width: 16px;
  height: 16px;
  color: rgb(var(--j-primary-color));
}

.avatar {
  margin-top: 10px;
  margin-right: 10px;
}
</style>
